// $ANTLR 3.5.3 Fol.g 2023-01-27 10:26:28

package sam.fol.antlr ;
import sam.lang.* ; 
import sam.fol.* ; 
import java.util.Vector ; 


import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;

/**
  *   ANTLR grammar for COFOL.  
  *   Follows TPTP formats mostly for wffs.
  *   EVAL: $ prefix signifies evaluation functor
  *   14 April 2011
  *   Type names can be any name, no special requirements.
  *   BE SURE TO SET CORRECT GENERATOR PATH!  e.g., /colog2.02/sam/fol/antlr
  *   
  */
@SuppressWarnings("all")
public class FolParser extends Parser {
	public static final String[] tokenNames = new String[] {
		"<invalid>", "<EOR>", "<DOWN>", "<UP>", "BOP", "DQUOTED", "EVAL", "LOWER", 
		"ML_COMMENT", "NUMERIC", "PRED", "QUOTED", "SL_COMMENT", "UOP", "UPPER", 
		"WS", "'!'", "'&'", "'('", "')'", "','", "'.'", "':'", "'<=>'", "'=>'", 
		"'?'", "'['", "']'", "'_'", "'{'", "'|'", "'}'", "'~'"
	};
	public static final int EOF=-1;
	public static final int T__16=16;
	public static final int T__17=17;
	public static final int T__18=18;
	public static final int T__19=19;
	public static final int T__20=20;
	public static final int T__21=21;
	public static final int T__22=22;
	public static final int T__23=23;
	public static final int T__24=24;
	public static final int T__25=25;
	public static final int T__26=26;
	public static final int T__27=27;
	public static final int T__28=28;
	public static final int T__29=29;
	public static final int T__30=30;
	public static final int T__31=31;
	public static final int T__32=32;
	public static final int BOP=4;
	public static final int DQUOTED=5;
	public static final int EVAL=6;
	public static final int LOWER=7;
	public static final int ML_COMMENT=8;
	public static final int NUMERIC=9;
	public static final int PRED=10;
	public static final int QUOTED=11;
	public static final int SL_COMMENT=12;
	public static final int UOP=13;
	public static final int UPPER=14;
	public static final int WS=15;

	// delegates
	public Parser[] getDelegates() {
		return new Parser[] {};
	}

	// delegators


	public FolParser(TokenStream input) {
		this(input, new RecognizerSharedState());
	}
	public FolParser(TokenStream input, RecognizerSharedState state) {
		super(input, state);
	}

	@Override public String[] getTokenNames() { return FolParser.tokenNames; }
	@Override public String getGrammarFileName() { return "Fol.g"; }


	/** Store Theory */
	Fol fol ;



	// $ANTLR start "test"
	// Fol.g:26:1: test : theory ;
	public final void test() throws RecognitionException {
		try {
			// Fol.g:26:7: ( theory )
			// Fol.g:26:10: theory
			{
			if ( state.backtracking==0 ) {fol = new Fol();}
			pushFollow(FOLLOW_theory_in_test50);
			theory();
			state._fsp--;
			if (state.failed) return;
			}

		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "test"



	// $ANTLR start "theory"
	// Fol.g:28:1: theory : (f= formula '.' )* ;
	public final void theory() throws RecognitionException {
		Formula f =null;

		try {
			// Fol.g:28:9: ( (f= formula '.' )* )
			// Fol.g:28:14: (f= formula '.' )*
			{
			// Fol.g:28:14: (f= formula '.' )*
			loop1:
			while (true) {
				int alt1=2;
				int LA1_0 = input.LA(1);
				if ( ((LA1_0 >= DQUOTED && LA1_0 <= LOWER)||(LA1_0 >= NUMERIC && LA1_0 <= QUOTED)||(LA1_0 >= UOP && LA1_0 <= UPPER)||LA1_0==16||LA1_0==18||LA1_0==25||(LA1_0 >= 28 && LA1_0 <= 29)||LA1_0==32) ) {
					alt1=1;
				}

				switch (alt1) {
				case 1 :
					// Fol.g:28:15: f= formula '.'
					{
					pushFollow(FOLLOW_formula_in_theory67);
					f=formula();
					state._fsp--;
					if (state.failed) return;
					if ( state.backtracking==0 ) {fol.theory.add(f);}
					match(input,21,FOLLOW_21_in_theory73); if (state.failed) return;
					}
					break;

				default :
					break loop1;
				}
			}

			}

		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "theory"



	// $ANTLR start "formula"
	// Fol.g:30:1: formula returns [Formula formula] : w= wff ;
	public final Formula formula() throws RecognitionException {
		Formula formula = null;


		WFF w =null;

		try {
			// Fol.g:30:35: (w= wff )
			// Fol.g:31:10: w= wff
			{
			pushFollow(FOLLOW_wff_in_formula100);
			w=wff();
			state._fsp--;
			if (state.failed) return formula;
			if ( state.backtracking==0 ) {formula = new Formula(w) ;  }
			}

		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
		}
		finally {
			// do for sure before leaving
		}
		return formula;
	}
	// $ANTLR end "formula"



	// $ANTLR start "wff"
	// Fol.g:35:1: wff returns [WFF value] : (p= predicate | '~' w= wff | '!' '[' v= varlist ']' ':' w= wff | '?' '[' v= varlist ']' ':' w= wff | ( '{' | '(' ) w1= wff ( '&' w2= wff ( '&' w2= wff )* | '|' w2= wff ( '|' w2= wff )* | '=>' w2= wff | '<=>' w2= wff ) ( '}' | ')' ) );
	public final WFF wff() throws RecognitionException {
		WFF value = null;


		Functor p =null;
		WFF w =null;
		Vector<TypedVariable> v =null;
		WFF w1 =null;
		WFF w2 =null;

		try {
			// Fol.g:35:25: (p= predicate | '~' w= wff | '!' '[' v= varlist ']' ':' w= wff | '?' '[' v= varlist ']' ':' w= wff | ( '{' | '(' ) w1= wff ( '&' w2= wff ( '&' w2= wff )* | '|' w2= wff ( '|' w2= wff )* | '=>' w2= wff | '<=>' w2= wff ) ( '}' | ')' ) )
			int alt5=5;
			switch ( input.LA(1) ) {
			case DQUOTED:
			case EVAL:
			case LOWER:
			case NUMERIC:
			case PRED:
			case QUOTED:
			case UOP:
			case UPPER:
			case 28:
				{
				alt5=1;
				}
				break;
			case 18:
				{
				int LA5_9 = input.LA(2);
				if ( (synpred2_Fol()) ) {
					alt5=1;
				}
				else if ( (true) ) {
					alt5=5;
				}

				}
				break;
			case 32:
				{
				alt5=2;
				}
				break;
			case 16:
				{
				alt5=3;
				}
				break;
			case 25:
				{
				alt5=4;
				}
				break;
			case 29:
				{
				alt5=5;
				}
				break;
			default:
				if (state.backtracking>0) {state.failed=true; return value;}
				NoViableAltException nvae =
					new NoViableAltException("", 5, 0, input);
				throw nvae;
			}
			switch (alt5) {
				case 1 :
					// Fol.g:36:7: p= predicate
					{
					pushFollow(FOLLOW_predicate_in_wff143);
					p=predicate();
					state._fsp--;
					if (state.failed) return value;
					if ( state.backtracking==0 ) {value = new WFF(WFF.FUNCTOR); value.operands.add(p) ;}
					}
					break;
				case 2 :
					// Fol.g:37:7: '~' w= wff
					{
					match(input,32,FOLLOW_32_in_wff153); if (state.failed) return value;
					pushFollow(FOLLOW_wff_in_wff157);
					w=wff();
					state._fsp--;
					if (state.failed) return value;
					if ( state.backtracking==0 ) {value = new WFF(WFF.NOT); value.operands.add(w) ;}
					}
					break;
				case 3 :
					// Fol.g:38:7: '!' '[' v= varlist ']' ':' w= wff
					{
					match(input,16,FOLLOW_16_in_wff167); if (state.failed) return value;
					match(input,26,FOLLOW_26_in_wff169); if (state.failed) return value;
					pushFollow(FOLLOW_varlist_in_wff173);
					v=varlist();
					state._fsp--;
					if (state.failed) return value;
					match(input,27,FOLLOW_27_in_wff175); if (state.failed) return value;
					match(input,22,FOLLOW_22_in_wff177); if (state.failed) return value;
					pushFollow(FOLLOW_wff_in_wff181);
					w=wff();
					state._fsp--;
					if (state.failed) return value;
					if ( state.backtracking==0 ) {value = new WFF(WFF.ALL); value.operands.add(v) ; value.operands.add(w) ;}
					}
					break;
				case 4 :
					// Fol.g:40:7: '?' '[' v= varlist ']' ':' w= wff
					{
					match(input,25,FOLLOW_25_in_wff200); if (state.failed) return value;
					match(input,26,FOLLOW_26_in_wff202); if (state.failed) return value;
					pushFollow(FOLLOW_varlist_in_wff206);
					v=varlist();
					state._fsp--;
					if (state.failed) return value;
					match(input,27,FOLLOW_27_in_wff208); if (state.failed) return value;
					match(input,22,FOLLOW_22_in_wff210); if (state.failed) return value;
					pushFollow(FOLLOW_wff_in_wff214);
					w=wff();
					state._fsp--;
					if (state.failed) return value;
					if ( state.backtracking==0 ) {value = new WFF(WFF.EXISTS); value.operands.add(v) ; value.operands.add(w) ;}
					}
					break;
				case 5 :
					// Fol.g:42:7: ( '{' | '(' ) w1= wff ( '&' w2= wff ( '&' w2= wff )* | '|' w2= wff ( '|' w2= wff )* | '=>' w2= wff | '<=>' w2= wff ) ( '}' | ')' )
					{
					if ( input.LA(1)==18||input.LA(1)==29 ) {
						input.consume();
						state.errorRecovery=false;
						state.failed=false;
					}
					else {
						if (state.backtracking>0) {state.failed=true; return value;}
						MismatchedSetException mse = new MismatchedSetException(null,input);
						throw mse;
					}
					pushFollow(FOLLOW_wff_in_wff245);
					w1=wff();
					state._fsp--;
					if (state.failed) return value;
					// Fol.g:43:8: ( '&' w2= wff ( '&' w2= wff )* | '|' w2= wff ( '|' w2= wff )* | '=>' w2= wff | '<=>' w2= wff )
					int alt4=4;
					switch ( input.LA(1) ) {
					case 17:
						{
						alt4=1;
						}
						break;
					case 30:
						{
						alt4=2;
						}
						break;
					case 24:
						{
						alt4=3;
						}
						break;
					case 23:
						{
						alt4=4;
						}
						break;
					default:
						if (state.backtracking>0) {state.failed=true; return value;}
						NoViableAltException nvae =
							new NoViableAltException("", 4, 0, input);
						throw nvae;
					}
					switch (alt4) {
						case 1 :
							// Fol.g:43:11: '&' w2= wff ( '&' w2= wff )*
							{
							match(input,17,FOLLOW_17_in_wff258); if (state.failed) return value;
							if ( state.backtracking==0 ) {value =new WFF(WFF.AND) ; value.operands.add(w1) ; }
							pushFollow(FOLLOW_wff_in_wff279);
							w2=wff();
							state._fsp--;
							if (state.failed) return value;
							if ( state.backtracking==0 ) {value.operands.add(w2) ; }
							// Fol.g:45:17: ( '&' w2= wff )*
							loop2:
							while (true) {
								int alt2=2;
								int LA2_0 = input.LA(1);
								if ( (LA2_0==17) ) {
									alt2=1;
								}

								switch (alt2) {
								case 1 :
									// Fol.g:45:18: '&' w2= wff
									{
									match(input,17,FOLLOW_17_in_wff301); if (state.failed) return value;
									pushFollow(FOLLOW_wff_in_wff305);
									w2=wff();
									state._fsp--;
									if (state.failed) return value;
									if ( state.backtracking==0 ) {value.operands.add(w2) ; }
									}
									break;

								default :
									break loop2;
								}
							}

							}
							break;
						case 2 :
							// Fol.g:46:12: '|' w2= wff ( '|' w2= wff )*
							{
							match(input,30,FOLLOW_30_in_wff323); if (state.failed) return value;
							if ( state.backtracking==0 ) {value =new WFF(WFF.OR) ; value.operands.add(w1) ; }
							pushFollow(FOLLOW_wff_in_wff344);
							w2=wff();
							state._fsp--;
							if (state.failed) return value;
							if ( state.backtracking==0 ) {value.operands.add(w2) ; }
							// Fol.g:48:15: ( '|' w2= wff )*
							loop3:
							while (true) {
								int alt3=2;
								int LA3_0 = input.LA(1);
								if ( (LA3_0==30) ) {
									alt3=1;
								}

								switch (alt3) {
								case 1 :
									// Fol.g:48:16: '|' w2= wff
									{
									match(input,30,FOLLOW_30_in_wff364); if (state.failed) return value;
									pushFollow(FOLLOW_wff_in_wff368);
									w2=wff();
									state._fsp--;
									if (state.failed) return value;
									if ( state.backtracking==0 ) {value.operands.add(w2) ; }
									}
									break;

								default :
									break loop3;
								}
							}

							}
							break;
						case 3 :
							// Fol.g:49:12: '=>' w2= wff
							{
							match(input,24,FOLLOW_24_in_wff385); if (state.failed) return value;
							if ( state.backtracking==0 ) {value =new WFF(WFF.IF) ; value.operands.add(w1) ; }
							pushFollow(FOLLOW_wff_in_wff406);
							w2=wff();
							state._fsp--;
							if (state.failed) return value;
							if ( state.backtracking==0 ) {value.operands.add(w2) ; }
							}
							break;
						case 4 :
							// Fol.g:51:12: '<=>' w2= wff
							{
							match(input,23,FOLLOW_23_in_wff422); if (state.failed) return value;
							if ( state.backtracking==0 ) {value =new WFF(WFF.IFF) ; value.operands.add(w1) ; }
							pushFollow(FOLLOW_wff_in_wff442);
							w2=wff();
							state._fsp--;
							if (state.failed) return value;
							if ( state.backtracking==0 ) {value.operands.add(w2) ; }
							}
							break;

					}

					if ( input.LA(1)==19||input.LA(1)==31 ) {
						input.consume();
						state.errorRecovery=false;
						state.failed=false;
					}
					else {
						if (state.backtracking>0) {state.failed=true; return value;}
						MismatchedSetException mse = new MismatchedSetException(null,input);
						throw mse;
					}
					}
					break;

			}
		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
		}
		finally {
			// do for sure before leaving
		}
		return value;
	}
	// $ANTLR end "wff"



	// $ANTLR start "predicate"
	// Fol.g:57:1: predicate returns [Functor value] : (f= functor ( PRED t= term )* |v= variable PRED t= term |n= number PRED t= term |o= operator PRED t= term );
	public final Functor predicate() throws RecognitionException {
		Functor value = null;


		Token PRED1=null;
		Token PRED2=null;
		Token PRED3=null;
		Token PRED4=null;
		Functor f =null;
		Term t =null;
		ParserRuleReturnScope v =null;
		ParserRuleReturnScope n =null;
		Functor o =null;

		try {
			// Fol.g:57:34: (f= functor ( PRED t= term )* |v= variable PRED t= term |n= number PRED t= term |o= operator PRED t= term )
			int alt7=4;
			switch ( input.LA(1) ) {
			case DQUOTED:
			case EVAL:
			case LOWER:
			case QUOTED:
				{
				alt7=1;
				}
				break;
			case UPPER:
			case 28:
				{
				alt7=2;
				}
				break;
			case NUMERIC:
				{
				alt7=3;
				}
				break;
			case EOF:
			case BOP:
			case PRED:
			case UOP:
			case 17:
			case 18:
			case 19:
			case 20:
			case 21:
			case 23:
			case 24:
			case 30:
			case 31:
				{
				alt7=4;
				}
				break;
			default:
				if (state.backtracking>0) {state.failed=true; return value;}
				NoViableAltException nvae =
					new NoViableAltException("", 7, 0, input);
				throw nvae;
			}
			switch (alt7) {
				case 1 :
					// Fol.g:58:10: f= functor ( PRED t= term )*
					{
					pushFollow(FOLLOW_functor_in_predicate513);
					f=functor();
					state._fsp--;
					if (state.failed) return value;
					if ( state.backtracking==0 ) {value = f ; }
					// Fol.g:59:11: ( PRED t= term )*
					loop6:
					while (true) {
						int alt6=2;
						int LA6_0 = input.LA(1);
						if ( (LA6_0==PRED) ) {
							alt6=1;
						}

						switch (alt6) {
						case 1 :
							// Fol.g:59:12: PRED t= term
							{
							PRED1=(Token)match(input,PRED,FOLLOW_PRED_in_predicate529); if (state.failed) return value;
							pushFollow(FOLLOW_term_in_predicate533);
							t=term();
							state._fsp--;
							if (state.failed) return value;
							if ( state.backtracking==0 ) { Vector<Term> v1 = new Vector<Term>() ;  v1.add(value) ; v1.add(t) ;    value = new Functor((PRED1!=null?PRED1.getText():null),v1,Functor.PRED) ; }
							}
							break;

						default :
							break loop6;
						}
					}

					}
					break;
				case 2 :
					// Fol.g:60:5: v= variable PRED t= term
					{
					pushFollow(FOLLOW_variable_in_predicate551);
					v=variable();
					state._fsp--;
					if (state.failed) return value;
					PRED2=(Token)match(input,PRED,FOLLOW_PRED_in_predicate553); if (state.failed) return value;
					pushFollow(FOLLOW_term_in_predicate557);
					t=term();
					state._fsp--;
					if (state.failed) return value;
					if ( state.backtracking==0 ) {Vector<Term> v2 = new Vector<Term>() ; v2.add((v!=null?((FolParser.variable_return)v).value:null)) ; v2.add(t) ; value = new Functor((PRED2!=null?PRED2.getText():null),v2,Functor.PRED) ; }
					}
					break;
				case 3 :
					// Fol.g:61:5: n= number PRED t= term
					{
					pushFollow(FOLLOW_number_in_predicate568);
					n=number();
					state._fsp--;
					if (state.failed) return value;
					PRED3=(Token)match(input,PRED,FOLLOW_PRED_in_predicate570); if (state.failed) return value;
					pushFollow(FOLLOW_term_in_predicate574);
					t=term();
					state._fsp--;
					if (state.failed) return value;
					if ( state.backtracking==0 ) {Vector<Term> v3 = new Vector<Term>() ; v3.add((n!=null?((FolParser.number_return)n).value:null)) ; v3.add(t) ; value = new Functor((PRED3!=null?PRED3.getText():null),v3,Functor.PRED) ; }
					}
					break;
				case 4 :
					// Fol.g:62:5: o= operator PRED t= term
					{
					pushFollow(FOLLOW_operator_in_predicate586);
					o=operator();
					state._fsp--;
					if (state.failed) return value;
					PRED4=(Token)match(input,PRED,FOLLOW_PRED_in_predicate588); if (state.failed) return value;
					pushFollow(FOLLOW_term_in_predicate592);
					t=term();
					state._fsp--;
					if (state.failed) return value;
					if ( state.backtracking==0 ) {Vector<Term> v3 = new Vector<Term>() ; v3.add(o) ; v3.add(t) ; value = new Functor((PRED4!=null?PRED4.getText():null),v3,Functor.PRED) ; }
					}
					break;

			}
		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
		}
		finally {
			// do for sure before leaving
		}
		return value;
	}
	// $ANTLR end "predicate"



	// $ANTLR start "functor"
	// Fol.g:65:1: functor returns [Functor value] : ( name | name '(' terms ')' );
	public final Functor functor() throws RecognitionException {
		Functor value = null;


		ParserRuleReturnScope name5 =null;
		ParserRuleReturnScope name6 =null;
		Vector<Term> terms7 =null;

		try {
			// Fol.g:65:35: ( name | name '(' terms ')' )
			int alt8=2;
			alt8 = dfa8.predict(input);
			switch (alt8) {
				case 1 :
					// Fol.g:66:5: name
					{
					pushFollow(FOLLOW_name_in_functor618);
					name5=name();
					state._fsp--;
					if (state.failed) return value;
					if ( state.backtracking==0 ) {value = new Functor((name5!=null?((FolParser.name_return)name5).value:null),0,Functor.FCNL) ; }
					}
					break;
				case 2 :
					// Fol.g:67:7: name '(' terms ')'
					{
					pushFollow(FOLLOW_name_in_functor629);
					name6=name();
					state._fsp--;
					if (state.failed) return value;
					match(input,18,FOLLOW_18_in_functor631); if (state.failed) return value;
					pushFollow(FOLLOW_terms_in_functor633);
					terms7=terms();
					state._fsp--;
					if (state.failed) return value;
					match(input,19,FOLLOW_19_in_functor635); if (state.failed) return value;
					if ( state.backtracking==0 ) {value = new Functor((name6!=null?((FolParser.name_return)name6).value:null), terms7,Functor.FCNL) ; }
					}
					break;

			}
		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
		}
		finally {
			// do for sure before leaving
		}
		return value;
	}
	// $ANTLR end "functor"



	// $ANTLR start "operator"
	// Fol.g:70:1: operator returns [Functor value] : (| UOP t= term | '(' t1= term BOP t2= term ')' );
	public final Functor operator() throws RecognitionException {
		Functor value = null;


		Token UOP8=null;
		Token BOP9=null;
		Term t =null;
		Term t1 =null;
		Term t2 =null;

		try {
			// Fol.g:70:34: (| UOP t= term | '(' t1= term BOP t2= term ')' )
			int alt9=3;
			switch ( input.LA(1) ) {
			case EOF:
			case BOP:
			case PRED:
			case 17:
			case 19:
			case 20:
			case 21:
			case 23:
			case 24:
			case 30:
			case 31:
				{
				alt9=1;
				}
				break;
			case UOP:
				{
				alt9=2;
				}
				break;
			case 18:
				{
				alt9=3;
				}
				break;
			default:
				if (state.backtracking>0) {state.failed=true; return value;}
				NoViableAltException nvae =
					new NoViableAltException("", 9, 0, input);
				throw nvae;
			}
			switch (alt9) {
				case 1 :
					// Fol.g:71:4: 
					{
					}
					break;
				case 2 :
					// Fol.g:71:6: UOP t= term
					{
					UOP8=(Token)match(input,UOP,FOLLOW_UOP_in_operator671); if (state.failed) return value;
					pushFollow(FOLLOW_term_in_operator675);
					t=term();
					state._fsp--;
					if (state.failed) return value;
					if ( state.backtracking==0 ) {Vector<Term> v = new Vector<Term>() ;  v.add(t) ; value = new Functor((UOP8!=null?UOP8.getText():null),v,Functor.UOP) ; }
					}
					break;
				case 3 :
					// Fol.g:72:6: '(' t1= term BOP t2= term ')'
					{
					match(input,18,FOLLOW_18_in_operator685); if (state.failed) return value;
					pushFollow(FOLLOW_term_in_operator688);
					t1=term();
					state._fsp--;
					if (state.failed) return value;
					BOP9=(Token)match(input,BOP,FOLLOW_BOP_in_operator690); if (state.failed) return value;
					pushFollow(FOLLOW_term_in_operator694);
					t2=term();
					state._fsp--;
					if (state.failed) return value;
					match(input,19,FOLLOW_19_in_operator696); if (state.failed) return value;
					if ( state.backtracking==0 ) {Vector<Term> v = new Vector<Term>() ;  v.add(t1) ; v.add(t2) ;value = new Functor((BOP9!=null?BOP9.getText():null),v,Functor.BOP) ; }
					}
					break;

			}
		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
		}
		finally {
			// do for sure before leaving
		}
		return value;
	}
	// $ANTLR end "operator"



	// $ANTLR start "terms"
	// Fol.g:75:1: terms returns [Vector<Term> value] :t= term ( ',' t= term )* ;
	public final Vector<Term> terms() throws RecognitionException {
		Vector<Term> value = null;


		Term t =null;

		try {
			// Fol.g:75:36: (t= term ( ',' t= term )* )
			// Fol.g:76:4: t= term ( ',' t= term )*
			{
			if ( state.backtracking==0 ) {value = new Vector<Term>() ;}
			pushFollow(FOLLOW_term_in_terms728);
			t=term();
			state._fsp--;
			if (state.failed) return value;
			if ( state.backtracking==0 ) {value.add(t);}
			// Fol.g:76:69: ( ',' t= term )*
			loop10:
			while (true) {
				int alt10=2;
				int LA10_0 = input.LA(1);
				if ( (LA10_0==20) ) {
					alt10=1;
				}

				switch (alt10) {
				case 1 :
					// Fol.g:76:70: ',' t= term
					{
					match(input,20,FOLLOW_20_in_terms734); if (state.failed) return value;
					pushFollow(FOLLOW_term_in_terms738);
					t=term();
					state._fsp--;
					if (state.failed) return value;
					if ( state.backtracking==0 ) {value.add(t);}
					}
					break;

				default :
					break loop10;
				}
			}

			}

		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
		}
		finally {
			// do for sure before leaving
		}
		return value;
	}
	// $ANTLR end "terms"



	// $ANTLR start "term"
	// Fol.g:78:1: term returns [Term value] : ( variable | number | functor | operator );
	public final Term term() throws RecognitionException {
		Term value = null;


		ParserRuleReturnScope variable10 =null;
		ParserRuleReturnScope number11 =null;
		Functor functor12 =null;
		Functor operator13 =null;

		try {
			// Fol.g:78:27: ( variable | number | functor | operator )
			int alt11=4;
			switch ( input.LA(1) ) {
			case UPPER:
			case 28:
				{
				alt11=1;
				}
				break;
			case NUMERIC:
				{
				alt11=2;
				}
				break;
			case DQUOTED:
			case EVAL:
			case LOWER:
			case QUOTED:
				{
				alt11=3;
				}
				break;
			case EOF:
			case BOP:
			case PRED:
			case UOP:
			case 17:
			case 18:
			case 19:
			case 20:
			case 21:
			case 23:
			case 24:
			case 30:
			case 31:
				{
				alt11=4;
				}
				break;
			default:
				if (state.backtracking>0) {state.failed=true; return value;}
				NoViableAltException nvae =
					new NoViableAltException("", 11, 0, input);
				throw nvae;
			}
			switch (alt11) {
				case 1 :
					// Fol.g:79:4: variable
					{
					pushFollow(FOLLOW_variable_in_term761);
					variable10=variable();
					state._fsp--;
					if (state.failed) return value;
					if ( state.backtracking==0 ) {value = (variable10!=null?((FolParser.variable_return)variable10).value:null) ; }
					}
					break;
				case 2 :
					// Fol.g:80:6: number
					{
					pushFollow(FOLLOW_number_in_term770);
					number11=number();
					state._fsp--;
					if (state.failed) return value;
					if ( state.backtracking==0 ) {value = (number11!=null?((FolParser.number_return)number11).value:null) ;}
					}
					break;
				case 3 :
					// Fol.g:81:6: functor
					{
					pushFollow(FOLLOW_functor_in_term781);
					functor12=functor();
					state._fsp--;
					if (state.failed) return value;
					if ( state.backtracking==0 ) {value = functor12 ; }
					}
					break;
				case 4 :
					// Fol.g:82:6: operator
					{
					pushFollow(FOLLOW_operator_in_term793);
					operator13=operator();
					state._fsp--;
					if (state.failed) return value;
					if ( state.backtracking==0 ) {value = operator13 ; }
					}
					break;

			}
		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
		}
		finally {
			// do for sure before leaving
		}
		return value;
	}
	// $ANTLR end "term"


	public static class number_return extends ParserRuleReturnScope {
		public Functor value;
	};


	// $ANTLR start "number"
	// Fol.g:84:1: number returns [Functor value] : ( NUMERIC )+ ;
	public final FolParser.number_return number() throws RecognitionException {
		FolParser.number_return retval = new FolParser.number_return();
		retval.start = input.LT(1);

		try {
			// Fol.g:84:31: ( ( NUMERIC )+ )
			// Fol.g:85:4: ( NUMERIC )+
			{
			// Fol.g:85:4: ( NUMERIC )+
			int cnt12=0;
			loop12:
			while (true) {
				int alt12=2;
				int LA12_0 = input.LA(1);
				if ( (LA12_0==NUMERIC) ) {
					alt12=1;
				}

				switch (alt12) {
				case 1 :
					// Fol.g:85:4: NUMERIC
					{
					match(input,NUMERIC,FOLLOW_NUMERIC_in_number811); if (state.failed) return retval;
					}
					break;

				default :
					if ( cnt12 >= 1 ) break loop12;
					if (state.backtracking>0) {state.failed=true; return retval;}
					EarlyExitException eee = new EarlyExitException(12, input);
					throw eee;
				}
				cnt12++;
			}

			if ( state.backtracking==0 ) {retval.value = new Functor(input.toString(retval.start,input.LT(-1)),0,Functor.FCNL) ; }
			}

			retval.stop = input.LT(-1);

		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "number"



	// $ANTLR start "varlist"
	// Fol.g:88:1: varlist returns [Vector<TypedVariable> value] :v= typedvariable ( ',' v= typedvariable )* ;
	public final Vector<TypedVariable> varlist() throws RecognitionException {
		Vector<TypedVariable> value = null;


		TypedVariable v =null;

		try {
			// Fol.g:88:48: (v= typedvariable ( ',' v= typedvariable )* )
			// Fol.g:89:4: v= typedvariable ( ',' v= typedvariable )*
			{
			if ( state.backtracking==0 ) {value = new Vector<TypedVariable>() ;}
			pushFollow(FOLLOW_typedvariable_in_varlist842);
			v=typedvariable();
			state._fsp--;
			if (state.failed) return value;
			if ( state.backtracking==0 ) {value.add(v);}
			// Fol.g:89:85: ( ',' v= typedvariable )*
			loop13:
			while (true) {
				int alt13=2;
				int LA13_0 = input.LA(1);
				if ( (LA13_0==20) ) {
					alt13=1;
				}

				switch (alt13) {
				case 1 :
					// Fol.g:89:86: ',' v= typedvariable
					{
					match(input,20,FOLLOW_20_in_varlist847); if (state.failed) return value;
					pushFollow(FOLLOW_typedvariable_in_varlist851);
					v=typedvariable();
					state._fsp--;
					if (state.failed) return value;
					if ( state.backtracking==0 ) {value.add(v);}
					}
					break;

				default :
					break loop13;
				}
			}

			}

		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
		}
		finally {
			// do for sure before leaving
		}
		return value;
	}
	// $ANTLR end "varlist"


	public static class variable_return extends ParserRuleReturnScope {
		public Variable value;
	};


	// $ANTLR start "variable"
	// Fol.g:91:1: variable returns [Variable value] : ( UPPER | '_' ) ( LOWER | UPPER | '_' | NUMERIC )* ;
	public final FolParser.variable_return variable() throws RecognitionException {
		FolParser.variable_return retval = new FolParser.variable_return();
		retval.start = input.LT(1);

		try {
			// Fol.g:91:35: ( ( UPPER | '_' ) ( LOWER | UPPER | '_' | NUMERIC )* )
			// Fol.g:92:4: ( UPPER | '_' ) ( LOWER | UPPER | '_' | NUMERIC )*
			{
			if ( input.LA(1)==UPPER||input.LA(1)==28 ) {
				input.consume();
				state.errorRecovery=false;
				state.failed=false;
			}
			else {
				if (state.backtracking>0) {state.failed=true; return retval;}
				MismatchedSetException mse = new MismatchedSetException(null,input);
				throw mse;
			}
			// Fol.g:92:16: ( LOWER | UPPER | '_' | NUMERIC )*
			loop14:
			while (true) {
				int alt14=2;
				int LA14_0 = input.LA(1);
				if ( (LA14_0==LOWER||LA14_0==NUMERIC||LA14_0==UPPER||LA14_0==28) ) {
					alt14=1;
				}

				switch (alt14) {
				case 1 :
					// Fol.g:
					{
					if ( input.LA(1)==LOWER||input.LA(1)==NUMERIC||input.LA(1)==UPPER||input.LA(1)==28 ) {
						input.consume();
						state.errorRecovery=false;
						state.failed=false;
					}
					else {
						if (state.backtracking>0) {state.failed=true; return retval;}
						MismatchedSetException mse = new MismatchedSetException(null,input);
						throw mse;
					}
					}
					break;

				default :
					break loop14;
				}
			}

			if ( state.backtracking==0 ) {retval.value = new Variable(input.toString(retval.start,input.LT(-1))) ; }
			}

			retval.stop = input.LT(-1);

		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "variable"



	// $ANTLR start "typedvariable"
	// Fol.g:95:1: typedvariable returns [TypedVariable value] : ( variable |v= variable ':' n= name );
	public final TypedVariable typedvariable() throws RecognitionException {
		TypedVariable value = null;


		ParserRuleReturnScope v =null;
		ParserRuleReturnScope n =null;
		ParserRuleReturnScope variable14 =null;

		try {
			// Fol.g:95:45: ( variable |v= variable ':' n= name )
			int alt15=2;
			alt15 = dfa15.predict(input);
			switch (alt15) {
				case 1 :
					// Fol.g:96:5: variable
					{
					pushFollow(FOLLOW_variable_in_typedvariable919);
					variable14=variable();
					state._fsp--;
					if (state.failed) return value;
					if ( state.backtracking==0 ) { value = new TypedVariable((variable14!=null?input.toString(variable14.start,variable14.stop):null),"dom") ; }
					}
					break;
				case 2 :
					// Fol.g:97:7: v= variable ':' n= name
					{
					pushFollow(FOLLOW_variable_in_typedvariable933);
					v=variable();
					state._fsp--;
					if (state.failed) return value;
					match(input,22,FOLLOW_22_in_typedvariable935); if (state.failed) return value;
					pushFollow(FOLLOW_name_in_typedvariable939);
					n=name();
					state._fsp--;
					if (state.failed) return value;
					if ( state.backtracking==0 ) { value = new TypedVariable((v!=null?input.toString(v.start,v.stop):null),(n!=null?((FolParser.name_return)n).value:null)) ; }
					}
					break;

			}
		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
		}
		finally {
			// do for sure before leaving
		}
		return value;
	}
	// $ANTLR end "typedvariable"


	public static class name_return extends ParserRuleReturnScope {
		public String value;
	};


	// $ANTLR start "name"
	// Fol.g:101:1: name returns [String value] : ( ( EVAL )* LOWER ( LOWER | UPPER | '_' | NUMERIC )* | QUOTED | DQUOTED );
	public final FolParser.name_return name() throws RecognitionException {
		FolParser.name_return retval = new FolParser.name_return();
		retval.start = input.LT(1);

		try {
			// Fol.g:101:28: ( ( EVAL )* LOWER ( LOWER | UPPER | '_' | NUMERIC )* | QUOTED | DQUOTED )
			int alt18=3;
			switch ( input.LA(1) ) {
			case EVAL:
			case LOWER:
				{
				alt18=1;
				}
				break;
			case QUOTED:
				{
				alt18=2;
				}
				break;
			case DQUOTED:
				{
				alt18=3;
				}
				break;
			default:
				if (state.backtracking>0) {state.failed=true; return retval;}
				NoViableAltException nvae =
					new NoViableAltException("", 18, 0, input);
				throw nvae;
			}
			switch (alt18) {
				case 1 :
					// Fol.g:102:4: ( EVAL )* LOWER ( LOWER | UPPER | '_' | NUMERIC )*
					{
					// Fol.g:102:4: ( EVAL )*
					loop16:
					while (true) {
						int alt16=2;
						int LA16_0 = input.LA(1);
						if ( (LA16_0==EVAL) ) {
							alt16=1;
						}

						switch (alt16) {
						case 1 :
							// Fol.g:102:4: EVAL
							{
							match(input,EVAL,FOLLOW_EVAL_in_name974); if (state.failed) return retval;
							}
							break;

						default :
							break loop16;
						}
					}

					match(input,LOWER,FOLLOW_LOWER_in_name977); if (state.failed) return retval;
					// Fol.g:102:16: ( LOWER | UPPER | '_' | NUMERIC )*
					loop17:
					while (true) {
						int alt17=2;
						int LA17_0 = input.LA(1);
						if ( (LA17_0==LOWER||LA17_0==NUMERIC||LA17_0==UPPER||LA17_0==28) ) {
							alt17=1;
						}

						switch (alt17) {
						case 1 :
							// Fol.g:
							{
							if ( input.LA(1)==LOWER||input.LA(1)==NUMERIC||input.LA(1)==UPPER||input.LA(1)==28 ) {
								input.consume();
								state.errorRecovery=false;
								state.failed=false;
							}
							else {
								if (state.backtracking>0) {state.failed=true; return retval;}
								MismatchedSetException mse = new MismatchedSetException(null,input);
								throw mse;
							}
							}
							break;

						default :
							break loop17;
						}
					}

					if ( state.backtracking==0 ) {retval.value = input.toString(retval.start,input.LT(-1)) ;}
					}
					break;
				case 2 :
					// Fol.g:103:6: QUOTED
					{
					match(input,QUOTED,FOLLOW_QUOTED_in_name1006); if (state.failed) return retval;
					if ( state.backtracking==0 ) { retval.value = input.toString(retval.start,input.LT(-1)) ; }
					}
					break;
				case 3 :
					// Fol.g:104:6: DQUOTED
					{
					match(input,DQUOTED,FOLLOW_DQUOTED_in_name1016); if (state.failed) return retval;
					if ( state.backtracking==0 ) { retval.value = input.toString(retval.start,input.LT(-1)) ; }
					}
					break;

			}
			retval.stop = input.LT(-1);

		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "name"

	// $ANTLR start synpred2_Fol
	public final void synpred2_Fol_fragment() throws RecognitionException {
		Functor p =null;

		// Fol.g:36:7: (p= predicate )
		// Fol.g:36:7: p= predicate
		{
		pushFollow(FOLLOW_predicate_in_synpred2_Fol143);
		p=predicate();
		state._fsp--;
		if (state.failed) return;
		}

	}
	// $ANTLR end synpred2_Fol

	// Delegated rules

	public final boolean synpred2_Fol() {
		state.backtracking++;
		int start = input.mark();
		try {
			synpred2_Fol_fragment(); // can never throw exception
		} catch (RecognitionException re) {
			System.err.println("impossible: "+re);
		}
		boolean success = !state.failed;
		input.rewind(start);
		state.backtracking--;
		state.failed=false;
		return success;
	}


	protected DFA8 dfa8 = new DFA8(this);
	protected DFA15 dfa15 = new DFA15(this);
	static final String DFA8_eotS =
		"\10\uffff";
	static final String DFA8_eofS =
		"\2\uffff\4\6\2\uffff";
	static final String DFA8_minS =
		"\1\5\1\6\4\4\2\uffff";
	static final String DFA8_maxS =
		"\1\13\1\7\4\37\2\uffff";
	static final String DFA8_acceptS =
		"\6\uffff\1\1\1\2";
	static final String DFA8_specialS =
		"\10\uffff}>";
	static final String[] DFA8_transitionS = {
			"\1\4\1\1\1\2\3\uffff\1\3",
			"\1\1\1\2",
			"\1\6\2\uffff\1\5\1\uffff\1\5\1\6\3\uffff\1\5\2\uffff\1\6\1\7\3\6\1\uffff"+
			"\2\6\3\uffff\1\5\1\uffff\2\6",
			"\1\6\5\uffff\1\6\6\uffff\1\6\1\7\3\6\1\uffff\2\6\5\uffff\2\6",
			"\1\6\5\uffff\1\6\6\uffff\1\6\1\7\3\6\1\uffff\2\6\5\uffff\2\6",
			"\1\6\2\uffff\1\5\1\uffff\1\5\1\6\3\uffff\1\5\2\uffff\1\6\1\7\3\6\1\uffff"+
			"\2\6\3\uffff\1\5\1\uffff\2\6",
			"",
			""
	};

	static final short[] DFA8_eot = DFA.unpackEncodedString(DFA8_eotS);
	static final short[] DFA8_eof = DFA.unpackEncodedString(DFA8_eofS);
	static final char[] DFA8_min = DFA.unpackEncodedStringToUnsignedChars(DFA8_minS);
	static final char[] DFA8_max = DFA.unpackEncodedStringToUnsignedChars(DFA8_maxS);
	static final short[] DFA8_accept = DFA.unpackEncodedString(DFA8_acceptS);
	static final short[] DFA8_special = DFA.unpackEncodedString(DFA8_specialS);
	static final short[][] DFA8_transition;

	static {
		int numStates = DFA8_transitionS.length;
		DFA8_transition = new short[numStates][];
		for (int i=0; i<numStates; i++) {
			DFA8_transition[i] = DFA.unpackEncodedString(DFA8_transitionS[i]);
		}
	}

	protected class DFA8 extends DFA {

		public DFA8(BaseRecognizer recognizer) {
			this.recognizer = recognizer;
			this.decisionNumber = 8;
			this.eot = DFA8_eot;
			this.eof = DFA8_eof;
			this.min = DFA8_min;
			this.max = DFA8_max;
			this.accept = DFA8_accept;
			this.special = DFA8_special;
			this.transition = DFA8_transition;
		}
		@Override
		public String getDescription() {
			return "65:1: functor returns [Functor value] : ( name | name '(' terms ')' );";
		}
	}

	static final String DFA15_eotS =
		"\5\uffff";
	static final String DFA15_eofS =
		"\1\uffff\2\3\2\uffff";
	static final String DFA15_minS =
		"\1\16\2\7\2\uffff";
	static final String DFA15_maxS =
		"\3\34\2\uffff";
	static final String DFA15_acceptS =
		"\3\uffff\1\1\1\2";
	static final String DFA15_specialS =
		"\5\uffff}>";
	static final String[] DFA15_transitionS = {
			"\1\1\15\uffff\1\1",
			"\1\2\1\uffff\1\2\4\uffff\1\2\5\uffff\1\3\1\uffff\1\4\4\uffff\1\3\1\2",
			"\1\2\1\uffff\1\2\4\uffff\1\2\5\uffff\1\3\1\uffff\1\4\4\uffff\1\3\1\2",
			"",
			""
	};

	static final short[] DFA15_eot = DFA.unpackEncodedString(DFA15_eotS);
	static final short[] DFA15_eof = DFA.unpackEncodedString(DFA15_eofS);
	static final char[] DFA15_min = DFA.unpackEncodedStringToUnsignedChars(DFA15_minS);
	static final char[] DFA15_max = DFA.unpackEncodedStringToUnsignedChars(DFA15_maxS);
	static final short[] DFA15_accept = DFA.unpackEncodedString(DFA15_acceptS);
	static final short[] DFA15_special = DFA.unpackEncodedString(DFA15_specialS);
	static final short[][] DFA15_transition;

	static {
		int numStates = DFA15_transitionS.length;
		DFA15_transition = new short[numStates][];
		for (int i=0; i<numStates; i++) {
			DFA15_transition[i] = DFA.unpackEncodedString(DFA15_transitionS[i]);
		}
	}

	protected class DFA15 extends DFA {

		public DFA15(BaseRecognizer recognizer) {
			this.recognizer = recognizer;
			this.decisionNumber = 15;
			this.eot = DFA15_eot;
			this.eof = DFA15_eof;
			this.min = DFA15_min;
			this.max = DFA15_max;
			this.accept = DFA15_accept;
			this.special = DFA15_special;
			this.transition = DFA15_transition;
		}
		@Override
		public String getDescription() {
			return "95:1: typedvariable returns [TypedVariable value] : ( variable |v= variable ':' n= name );";
		}
	}

	public static final BitSet FOLLOW_theory_in_test50 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_formula_in_theory67 = new BitSet(new long[]{0x0000000000200000L});
	public static final BitSet FOLLOW_21_in_theory73 = new BitSet(new long[]{0x0000000132056EE2L});
	public static final BitSet FOLLOW_wff_in_formula100 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_predicate_in_wff143 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_32_in_wff153 = new BitSet(new long[]{0x0000000132056EE0L});
	public static final BitSet FOLLOW_wff_in_wff157 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_16_in_wff167 = new BitSet(new long[]{0x0000000004000000L});
	public static final BitSet FOLLOW_26_in_wff169 = new BitSet(new long[]{0x0000000010004000L});
	public static final BitSet FOLLOW_varlist_in_wff173 = new BitSet(new long[]{0x0000000008000000L});
	public static final BitSet FOLLOW_27_in_wff175 = new BitSet(new long[]{0x0000000000400000L});
	public static final BitSet FOLLOW_22_in_wff177 = new BitSet(new long[]{0x0000000132056EE0L});
	public static final BitSet FOLLOW_wff_in_wff181 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_25_in_wff200 = new BitSet(new long[]{0x0000000004000000L});
	public static final BitSet FOLLOW_26_in_wff202 = new BitSet(new long[]{0x0000000010004000L});
	public static final BitSet FOLLOW_varlist_in_wff206 = new BitSet(new long[]{0x0000000008000000L});
	public static final BitSet FOLLOW_27_in_wff208 = new BitSet(new long[]{0x0000000000400000L});
	public static final BitSet FOLLOW_22_in_wff210 = new BitSet(new long[]{0x0000000132056EE0L});
	public static final BitSet FOLLOW_wff_in_wff214 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_set_in_wff233 = new BitSet(new long[]{0x0000000132056EE0L});
	public static final BitSet FOLLOW_wff_in_wff245 = new BitSet(new long[]{0x0000000041820000L});
	public static final BitSet FOLLOW_17_in_wff258 = new BitSet(new long[]{0x0000000132056EE0L});
	public static final BitSet FOLLOW_wff_in_wff279 = new BitSet(new long[]{0x00000000800A0000L});
	public static final BitSet FOLLOW_17_in_wff301 = new BitSet(new long[]{0x0000000132056EE0L});
	public static final BitSet FOLLOW_wff_in_wff305 = new BitSet(new long[]{0x00000000800A0000L});
	public static final BitSet FOLLOW_30_in_wff323 = new BitSet(new long[]{0x0000000132056EE0L});
	public static final BitSet FOLLOW_wff_in_wff344 = new BitSet(new long[]{0x00000000C0080000L});
	public static final BitSet FOLLOW_30_in_wff364 = new BitSet(new long[]{0x0000000132056EE0L});
	public static final BitSet FOLLOW_wff_in_wff368 = new BitSet(new long[]{0x00000000C0080000L});
	public static final BitSet FOLLOW_24_in_wff385 = new BitSet(new long[]{0x0000000132056EE0L});
	public static final BitSet FOLLOW_wff_in_wff406 = new BitSet(new long[]{0x0000000080080000L});
	public static final BitSet FOLLOW_23_in_wff422 = new BitSet(new long[]{0x0000000132056EE0L});
	public static final BitSet FOLLOW_wff_in_wff442 = new BitSet(new long[]{0x0000000080080000L});
	public static final BitSet FOLLOW_set_in_wff470 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_functor_in_predicate513 = new BitSet(new long[]{0x0000000000000402L});
	public static final BitSet FOLLOW_PRED_in_predicate529 = new BitSet(new long[]{0x0000000010046AE0L});
	public static final BitSet FOLLOW_term_in_predicate533 = new BitSet(new long[]{0x0000000000000402L});
	public static final BitSet FOLLOW_variable_in_predicate551 = new BitSet(new long[]{0x0000000000000400L});
	public static final BitSet FOLLOW_PRED_in_predicate553 = new BitSet(new long[]{0x0000000010046AE0L});
	public static final BitSet FOLLOW_term_in_predicate557 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_number_in_predicate568 = new BitSet(new long[]{0x0000000000000400L});
	public static final BitSet FOLLOW_PRED_in_predicate570 = new BitSet(new long[]{0x0000000010046AE0L});
	public static final BitSet FOLLOW_term_in_predicate574 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_operator_in_predicate586 = new BitSet(new long[]{0x0000000000000400L});
	public static final BitSet FOLLOW_PRED_in_predicate588 = new BitSet(new long[]{0x0000000010046AE0L});
	public static final BitSet FOLLOW_term_in_predicate592 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_name_in_functor618 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_name_in_functor629 = new BitSet(new long[]{0x0000000000040000L});
	public static final BitSet FOLLOW_18_in_functor631 = new BitSet(new long[]{0x0000000010046AE0L});
	public static final BitSet FOLLOW_terms_in_functor633 = new BitSet(new long[]{0x0000000000080000L});
	public static final BitSet FOLLOW_19_in_functor635 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_UOP_in_operator671 = new BitSet(new long[]{0x0000000010046AE0L});
	public static final BitSet FOLLOW_term_in_operator675 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_18_in_operator685 = new BitSet(new long[]{0x0000000010046AE0L});
	public static final BitSet FOLLOW_term_in_operator688 = new BitSet(new long[]{0x0000000000000010L});
	public static final BitSet FOLLOW_BOP_in_operator690 = new BitSet(new long[]{0x0000000010046AE0L});
	public static final BitSet FOLLOW_term_in_operator694 = new BitSet(new long[]{0x0000000000080000L});
	public static final BitSet FOLLOW_19_in_operator696 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_term_in_terms728 = new BitSet(new long[]{0x0000000000100002L});
	public static final BitSet FOLLOW_20_in_terms734 = new BitSet(new long[]{0x0000000010046AE0L});
	public static final BitSet FOLLOW_term_in_terms738 = new BitSet(new long[]{0x0000000000100002L});
	public static final BitSet FOLLOW_variable_in_term761 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_number_in_term770 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_functor_in_term781 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_operator_in_term793 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_NUMERIC_in_number811 = new BitSet(new long[]{0x0000000000000202L});
	public static final BitSet FOLLOW_typedvariable_in_varlist842 = new BitSet(new long[]{0x0000000000100002L});
	public static final BitSet FOLLOW_20_in_varlist847 = new BitSet(new long[]{0x0000000010004000L});
	public static final BitSet FOLLOW_typedvariable_in_varlist851 = new BitSet(new long[]{0x0000000000100002L});
	public static final BitSet FOLLOW_set_in_variable873 = new BitSet(new long[]{0x0000000010004282L});
	public static final BitSet FOLLOW_variable_in_typedvariable919 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_variable_in_typedvariable933 = new BitSet(new long[]{0x0000000000400000L});
	public static final BitSet FOLLOW_22_in_typedvariable935 = new BitSet(new long[]{0x00000000000008E0L});
	public static final BitSet FOLLOW_name_in_typedvariable939 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_EVAL_in_name974 = new BitSet(new long[]{0x00000000000000C0L});
	public static final BitSet FOLLOW_LOWER_in_name977 = new BitSet(new long[]{0x0000000010004282L});
	public static final BitSet FOLLOW_QUOTED_in_name1006 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_DQUOTED_in_name1016 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_predicate_in_synpred2_Fol143 = new BitSet(new long[]{0x0000000000000002L});
}
