package sam.lang ; 

/**
  *  Light-weight Inference 
  *  (grounded rule used for branch inference)
  *  @version 7 April 2015
  *  @author &copy; John Fisher 
   */
public class Inference { 
   public And antecedent ; 
   public And[] consequent ; 

   /**
     *  Construct a Inference.
      */
   public Inference(And ant, And[] cons ) {   
      this.antecedent = ant ;          
      this.consequent = cons ; 
   }

   /**
     *  Create string representation. 
     */
   public String toString(Theory theory) { 
      StringBuffer sb = new StringBuffer() ; 
      sb.append(this.antecedent.toString(theory)) ; 
      sb.append(" => ") ; 
      for(int d = 0 ; d < this.consequent.length ; d++) {
         sb.append(this.consequent[d].toString(theory)) ;
         if (d < this.consequent.length-1) sb.append(" | ") ;
      }
      return sb.toString() ;  
   }

}
