package sam.lang ; 

import java.util.* ; 

/**
  * colog Term 
  * Super class for Functor or Variable.
  * Terms are the args of Functors.
  * @version 2 April 2014
  * @author &copy; John Fisher 
  */
public class Term { 

   public int index ; 

   /**
     * Is this Term a Variable. 
     * If not then it is a Functor.
     */
   public boolean isVariable() {
      return (this instanceof sam.lang.Variable) ; 
   }

   /**
     * Is this Term a constant -- 
     * contains no variables.  Added 27 July 2009.
     */
   public boolean isConstant() {
      if (this.isVariable()) return false ;
      if (((Functor)this).arity == 0) return true ;
      else
         for (int i = 0 ; i < ((Functor)this).arity ; i++) 
            if (!((Functor)this).args[i].isConstant()) return false ;
         return true ; 
   }

   public String toString() { // probably not needed ;-)
      if (this.isVariable()) return ((Variable)this).toString() ; 
      else return ((Functor)this).toString() ;
   }

//   public String toFOLString() { // probably not needed ;-)
//      return this.toString() ; 
//      //if (this.isVariable()) return ((Variable)this).toString() ; 
//      //else return ((Functor)this).toString() ;
//   }

   /**
     *  Create HTML representation of term in consequent, red flag existential variables. 
     */
   public String toHTML(int U) { 
      if (this.isVariable()) return ((Variable)this).toHTML(U) ; 
      else return ((Functor)this).toHTML(U) ;
   }


   /**
     *  test stub 
     */
   public static void main(String[] args) {
      TypedVariable tv1 = new TypedVariable("crumb","dumb") ;
      TypedVariable tv2 = new TypedVariable("crumb","cumb") ;
      System.out.println(tv1.typename) ;
      System.out.println(tv2.typename) ;
      System.out.println(tv1 instanceof TypedVariable) ;
      System.out.println(tv2 instanceof TypedVariable) ;

      System.out.println(tv1.equals(tv2)) ;
   }



}
