package sam.lang ; 

import java.util.* ; 

/**
  * Geolog Variable
  * @version 2 April 2014
  * @author &copy; John Fisher 
  */
public class Variable extends Term {

   public String name ; 
   
   /**
     *  Construct a Geolog Variable by name.
     *  The user's name for the Variable is its display name.
     */
   public Variable(String n) { 
      this.name = n ; 
      this.index = 0 ; // reset later
   }

   /**
     *  Return the (String) name of this Geolog variable.
     */
   public String toString() { 
      return this.name ;  
      //return this.name +"/"+this.index ;  // view indexing
   }

   /**
     *  Return the HTML name of this Variable, 
     *  red flag existential variables.
     */
   public String toHTML(int U) { 
      if (this.index < U)
         return this.name ;  // +"/"+this.index ;  
      else
         return "<font color = \"RED\">"+this.name+"</font>" ; 
   }
   
   /**
     *  Clone this Variable.
     */
   public Variable clone() { 
      return new Variable(this.name) ; 
   }

   /***
      *  equals by .name
      *  var table by index
       */
   public boolean equals(Object obj) { 
      if (!(obj instanceof Variable)) return false ; 
      return (this.name).equals(((Variable)obj).name) ; 
   }

   /***
      *  hash code per equals
       */
   public int hashCode() { 
      return this.name.hashCode()  ; 
   }


   public static void main(String[] args) { 
      Variable x1 = new Variable("X") ;
      Variable x2 = new Variable("X") ;
      System.out.println(x1.equals(x2)) ; 
      System.out.println(x1.name.equals(x2.name)) ; 
   }
}



