// $ANTLR 3.5.3 colog.g 2023-01-27 10:12:17

package sam.lang.antlr ;
import sam.lang.* ; 
import java.util.Vector ; 


import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

/**
  *  A colog code grammar.
  *  Algebra -- infix functors -- needs to be fully parenthesized.
  *  @author jrfisher@csupomona.edu
  *  30 December 2013 version, hints
  *  BE SURE TO SET GENERATOR PATH: e.g., /colog2.1/sam/lang/antlr
  */
@SuppressWarnings("all")
public class cologParser extends Parser {
	public static final String[] tokenNames = new String[] {
		"<invalid>", "<EOR>", "<DOWN>", "<UP>", "ALL", "DQUOTED", "LOWER", "ML_COMMENT", 
		"NUMERIC", "QUOTED", "SL_COMMENT", "UOP", "UPPER", "WS", "'!='", "'#'", 
		"'$'", "'&'", "'('", "')'", "'*'", "'+'", "','", "'- '", "'->'", "'.'", 
		"'/'", "';'", "'<'", "'<='", "'='", "'=>'", "'>'", "'>='", "'\\\\'", "'^'", 
		"'_'", "'|'", "'~'"
	};
	public static final int EOF=-1;
	public static final int T__14=14;
	public static final int T__15=15;
	public static final int T__16=16;
	public static final int T__17=17;
	public static final int T__18=18;
	public static final int T__19=19;
	public static final int T__20=20;
	public static final int T__21=21;
	public static final int T__22=22;
	public static final int T__23=23;
	public static final int T__24=24;
	public static final int T__25=25;
	public static final int T__26=26;
	public static final int T__27=27;
	public static final int T__28=28;
	public static final int T__29=29;
	public static final int T__30=30;
	public static final int T__31=31;
	public static final int T__32=32;
	public static final int T__33=33;
	public static final int T__34=34;
	public static final int T__35=35;
	public static final int T__36=36;
	public static final int T__37=37;
	public static final int T__38=38;
	public static final int ALL=4;
	public static final int DQUOTED=5;
	public static final int LOWER=6;
	public static final int ML_COMMENT=7;
	public static final int NUMERIC=8;
	public static final int QUOTED=9;
	public static final int SL_COMMENT=10;
	public static final int UOP=11;
	public static final int UPPER=12;
	public static final int WS=13;

	// delegates
	public Parser[] getDelegates() {
		return new Parser[] {};
	}

	// delegators


	public cologParser(TokenStream input) {
		this(input, new RecognizerSharedState());
	}
	public cologParser(TokenStream input, RecognizerSharedState state) {
		super(input, state);
	}

	@Override public String[] getTokenNames() { return cologParser.tokenNames; }
	@Override public String getGrammarFileName() { return "colog.g"; }


	/** Store Theory */
	Theory cologTheory ;



	// $ANTLR start "test"
	// colog.g:22:1: test : theory ;
	public final void test() throws RecognitionException {
		try {
			// colog.g:22:6: ( theory )
			// colog.g:22:8: theory
			{
			cologTheory= new Theory() ; 
			pushFollow(FOLLOW_theory_in_test35);
			theory();
			state._fsp--;

			}

		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "test"



	// $ANTLR start "theory"
	// colog.g:24:1: theory : ( hint )* (r= rule '.' )+ ;
	public final void theory() throws RecognitionException {
		Rule r =null;

		try {
			// colog.g:24:8: ( ( hint )* (r= rule '.' )+ )
			// colog.g:25:4: ( hint )* (r= rule '.' )+
			{
			// colog.g:25:4: ( hint )*
			loop1:
			while (true) {
				int alt1=2;
				alt1 = dfa1.predict(input);
				switch (alt1) {
				case 1 :
					// colog.g:25:4: hint
					{
					pushFollow(FOLLOW_hint_in_theory53);
					hint();
					state._fsp--;

					}
					break;

				default :
					break loop1;
				}
			}

			// colog.g:25:10: (r= rule '.' )+
			int cnt2=0;
			loop2:
			while (true) {
				int alt2=2;
				int LA2_0 = input.LA(1);
				if ( ((LA2_0 >= ALL && LA2_0 <= LOWER)||(LA2_0 >= NUMERIC && LA2_0 <= QUOTED)||(LA2_0 >= UOP && LA2_0 <= UPPER)||LA2_0==16||LA2_0==18||LA2_0==36||LA2_0==38) ) {
					alt2=1;
				}

				switch (alt2) {
				case 1 :
					// colog.g:25:12: r= rule '.'
					{
					pushFollow(FOLLOW_rule_in_theory60);
					r=rule();
					state._fsp--;

					cologTheory.add(r);
					match(input,25,FOLLOW_25_in_theory66); 
					}
					break;

				default :
					if ( cnt2 >= 1 ) break loop2;
					EarlyExitException eee = new EarlyExitException(2, input);
					throw eee;
				}
				cnt2++;
			}

			}

		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "theory"



	// $ANTLR start "hint"
	// colog.g:27:1: hint : attr= name '=' (n= number |v= name ) '.' ;
	public final void hint() throws RecognitionException {
		ParserRuleReturnScope attr =null;
		ParserRuleReturnScope n =null;
		ParserRuleReturnScope v =null;

		try {
			// colog.g:27:6: (attr= name '=' (n= number |v= name ) '.' )
			// colog.g:27:8: attr= name '=' (n= number |v= name ) '.'
			{
			pushFollow(FOLLOW_name_in_hint81);
			attr=name();
			state._fsp--;

			match(input,30,FOLLOW_30_in_hint83); 
			// colog.g:27:22: (n= number |v= name )
			int alt3=2;
			int LA3_0 = input.LA(1);
			if ( (LA3_0==NUMERIC) ) {
				alt3=1;
			}
			else if ( ((LA3_0 >= ALL && LA3_0 <= LOWER)||LA3_0==QUOTED||LA3_0==16||LA3_0==38) ) {
				alt3=2;
			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 3, 0, input);
				throw nvae;
			}

			switch (alt3) {
				case 1 :
					// colog.g:27:23: n= number
					{
					pushFollow(FOLLOW_number_in_hint88);
					n=number();
					state._fsp--;

					 cologTheory.hints.put((attr!=null?((cologParser.name_return)attr).value:null),(n!=null?((cologParser.number_return)n).value:null)) ;
					}
					break;
				case 2 :
					// colog.g:28:25: v= name
					{
					pushFollow(FOLLOW_name_in_hint119);
					v=name();
					state._fsp--;

					 cologTheory.hints.put((attr!=null?((cologParser.name_return)attr).value:null),(v!=null?((cologParser.name_return)v).value:null)) ;
					}
					break;

			}

			match(input,25,FOLLOW_25_in_hint124); 
			}

		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "hint"



	// $ANTLR start "rule"
	// colog.g:30:1: rule returns [Rule value] : conjunction '=>' disjunction ;
	public final Rule rule() throws RecognitionException {
		Rule value = null;


		Conjunction conjunction1 =null;
		Disjunction disjunction2 =null;

		try {
			// colog.g:30:26: ( conjunction '=>' disjunction )
			// colog.g:31:4: conjunction '=>' disjunction
			{
			pushFollow(FOLLOW_conjunction_in_rule142);
			conjunction1=conjunction();
			state._fsp--;

			match(input,31,FOLLOW_31_in_rule144); 
			pushFollow(FOLLOW_disjunction_in_rule146);
			disjunction2=disjunction();
			state._fsp--;

			value =new Rule(conjunction1,disjunction2) ; 
			}

		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
		}
		finally {
			// do for sure before leaving
		}
		return value;
	}
	// $ANTLR end "rule"



	// $ANTLR start "disjunction"
	// colog.g:34:1: disjunction returns [Disjunction value] :c= conjunction ( ( ';' | '|' ) c= conjunction )* ;
	public final Disjunction disjunction() throws RecognitionException {
		Disjunction value = null;


		Conjunction c =null;

		try {
			// colog.g:34:41: (c= conjunction ( ( ';' | '|' ) c= conjunction )* )
			// colog.g:35:4: c= conjunction ( ( ';' | '|' ) c= conjunction )*
			{
			value =new Disjunction();
			pushFollow(FOLLOW_conjunction_in_disjunction179);
			c=conjunction();
			state._fsp--;

			value.add(c) ; 
			// colog.g:37:4: ( ( ';' | '|' ) c= conjunction )*
			loop4:
			while (true) {
				int alt4=2;
				int LA4_0 = input.LA(1);
				if ( (LA4_0==27||LA4_0==37) ) {
					alt4=1;
				}

				switch (alt4) {
				case 1 :
					// colog.g:37:5: ( ';' | '|' ) c= conjunction
					{
					if ( input.LA(1)==27||input.LA(1)==37 ) {
						input.consume();
						state.errorRecovery=false;
					}
					else {
						MismatchedSetException mse = new MismatchedSetException(null,input);
						throw mse;
					}
					pushFollow(FOLLOW_conjunction_in_disjunction197);
					c=conjunction();
					state._fsp--;

					value.add(c) ; 
					}
					break;

				default :
					break loop4;
				}
			}

			}

		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
		}
		finally {
			// do for sure before leaving
		}
		return value;
	}
	// $ANTLR end "disjunction"



	// $ANTLR start "conjunction"
	// colog.g:39:1: conjunction returns [Conjunction value] :p= predicate ( ',' p= predicate )* ;
	public final Conjunction conjunction() throws RecognitionException {
		Conjunction value = null;


		Functor p =null;

		try {
			// colog.g:39:41: (p= predicate ( ',' p= predicate )* )
			// colog.g:40:4: p= predicate ( ',' p= predicate )*
			{
			value =new Conjunction(); 
			pushFollow(FOLLOW_predicate_in_conjunction227);
			p=predicate();
			state._fsp--;

			value.add(p) ; 
			// colog.g:42:4: ( ',' p= predicate )*
			loop5:
			while (true) {
				int alt5=2;
				int LA5_0 = input.LA(1);
				if ( (LA5_0==22) ) {
					alt5=1;
				}

				switch (alt5) {
				case 1 :
					// colog.g:42:5: ',' p= predicate
					{
					match(input,22,FOLLOW_22_in_conjunction237); 
					pushFollow(FOLLOW_predicate_in_conjunction241);
					p=predicate();
					state._fsp--;

					value.add(p) ; 
					}
					break;

				default :
					break loop5;
				}
			}

			}

		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
		}
		finally {
			// do for sure before leaving
		}
		return value;
	}
	// $ANTLR end "conjunction"



	// $ANTLR start "predicate"
	// colog.g:44:1: predicate returns [Functor value] : (f= functor ( pred t= term )* |v= variable pred t= term |n= number pred t= term );
	public final Functor predicate() throws RecognitionException {
		Functor value = null;


		Functor f =null;
		Term t =null;
		ParserRuleReturnScope v =null;
		ParserRuleReturnScope n =null;
		ParserRuleReturnScope pred3 =null;
		ParserRuleReturnScope pred4 =null;
		ParserRuleReturnScope pred5 =null;

		try {
			// colog.g:45:2: (f= functor ( pred t= term )* |v= variable pred t= term |n= number pred t= term )
			int alt7=3;
			switch ( input.LA(1) ) {
			case ALL:
			case DQUOTED:
			case LOWER:
			case QUOTED:
			case UOP:
			case 16:
			case 18:
			case 38:
				{
				alt7=1;
				}
				break;
			case UPPER:
			case 36:
				{
				alt7=2;
				}
				break;
			case NUMERIC:
				{
				alt7=3;
				}
				break;
			default:
				NoViableAltException nvae =
					new NoViableAltException("", 7, 0, input);
				throw nvae;
			}
			switch (alt7) {
				case 1 :
					// colog.g:45:4: f= functor ( pred t= term )*
					{
					pushFollow(FOLLOW_functor_in_predicate261);
					f=functor();
					state._fsp--;

					value = f ; 
					// colog.g:46:2: ( pred t= term )*
					loop6:
					while (true) {
						int alt6=2;
						int LA6_0 = input.LA(1);
						if ( (LA6_0==14||LA6_0==16||(LA6_0 >= 28 && LA6_0 <= 30)||(LA6_0 >= 32 && LA6_0 <= 33)) ) {
							alt6=1;
						}

						switch (alt6) {
						case 1 :
							// colog.g:46:3: pred t= term
							{
							pushFollow(FOLLOW_pred_in_predicate268);
							pred3=pred();
							state._fsp--;

							pushFollow(FOLLOW_term_in_predicate272);
							t=term();
							state._fsp--;

							 Vector<Term> v1 = new Vector<Term>() ;  v1.add(value) ; v1.add(t) ;    value = new Functor((pred3!=null?input.toString(pred3.start,pred3.stop):null),v1,Functor.PRED) ; 
							}
							break;

						default :
							break loop6;
						}
					}

					}
					break;
				case 2 :
					// colog.g:47:5: v= variable pred t= term
					{
					pushFollow(FOLLOW_variable_in_predicate291);
					v=variable();
					state._fsp--;

					pushFollow(FOLLOW_pred_in_predicate293);
					pred4=pred();
					state._fsp--;

					pushFollow(FOLLOW_term_in_predicate297);
					t=term();
					state._fsp--;

					Vector<Term> v2 = new Vector<Term>() ; v2.add((v!=null?((cologParser.variable_return)v).value:null)) ; v2.add(t) ; value = new Functor((pred4!=null?input.toString(pred4.start,pred4.stop):null),v2,Functor.PRED) ; 
					}
					break;
				case 3 :
					// colog.g:48:5: n= number pred t= term
					{
					pushFollow(FOLLOW_number_in_predicate308);
					n=number();
					state._fsp--;

					pushFollow(FOLLOW_pred_in_predicate310);
					pred5=pred();
					state._fsp--;

					pushFollow(FOLLOW_term_in_predicate314);
					t=term();
					state._fsp--;

					Vector<Term> v3 = new Vector<Term>() ; v3.add(new Functor((n!=null?((cologParser.number_return)n).value:null),0,Functor.FCNL)) ; v3.add(t) ; value = new Functor((pred5!=null?input.toString(pred5.start,pred5.stop):null),v3,Functor.PRED) ; 
					}
					break;

			}
		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
		}
		finally {
			// do for sure before leaving
		}
		return value;
	}
	// $ANTLR end "predicate"



	// $ANTLR start "functor"
	// colog.g:51:1: functor returns [Functor value] : ( name '(' terms ')' | name | '(' t1= term bop t2= term ')' | UOP t= term );
	public final Functor functor() throws RecognitionException {
		Functor value = null;


		Token UOP10=null;
		Term t1 =null;
		Term t2 =null;
		Term t =null;
		ParserRuleReturnScope name6 =null;
		Vector<Term> terms7 =null;
		ParserRuleReturnScope name8 =null;
		ParserRuleReturnScope bop9 =null;

		try {
			// colog.g:51:35: ( name '(' terms ')' | name | '(' t1= term bop t2= term ')' | UOP t= term )
			int alt8=4;
			alt8 = dfa8.predict(input);
			switch (alt8) {
				case 1 :
					// colog.g:52:6: name '(' terms ')'
					{
					pushFollow(FOLLOW_name_in_functor339);
					name6=name();
					state._fsp--;

					match(input,18,FOLLOW_18_in_functor341); 
					pushFollow(FOLLOW_terms_in_functor343);
					terms7=terms();
					state._fsp--;

					match(input,19,FOLLOW_19_in_functor345); 
					value = new Functor((name6!=null?((cologParser.name_return)name6).value:null), terms7,Functor.FCNL) ; 
					}
					break;
				case 2 :
					// colog.g:53:6: name
					{
					pushFollow(FOLLOW_name_in_functor365);
					name8=name();
					state._fsp--;

					value = new Functor((name8!=null?((cologParser.name_return)name8).value:null),0,Functor.FCNL) ; 
					}
					break;
				case 3 :
					// colog.g:54:6: '(' t1= term bop t2= term ')'
					{
					match(input,18,FOLLOW_18_in_functor375); 
					pushFollow(FOLLOW_term_in_functor379);
					t1=term();
					state._fsp--;

					pushFollow(FOLLOW_bop_in_functor381);
					bop9=bop();
					state._fsp--;

					pushFollow(FOLLOW_term_in_functor385);
					t2=term();
					state._fsp--;

					match(input,19,FOLLOW_19_in_functor387); 
					Vector<Term> v = new Vector<Term>() ;  v.add(t1) ; v.add(t2) ;  value = new Functor((bop9!=null?input.toString(bop9.start,bop9.stop):null),v,Functor.BOP) ; 
					}
					break;
				case 4 :
					// colog.g:55:6: UOP t= term
					{
					UOP10=(Token)match(input,UOP,FOLLOW_UOP_in_functor397); 
					pushFollow(FOLLOW_term_in_functor401);
					t=term();
					state._fsp--;

					Vector<Term> v = new Vector<Term>() ;  v.add(t) ; value = new Functor((UOP10!=null?UOP10.getText():null),v,Functor.UOP) ; 
					}
					break;

			}
		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
		}
		finally {
			// do for sure before leaving
		}
		return value;
	}
	// $ANTLR end "functor"



	// $ANTLR start "terms"
	// colog.g:58:1: terms returns [Vector<Term> value] :t= term ( ',' t= term )* ;
	public final Vector<Term> terms() throws RecognitionException {
		Vector<Term> value = null;


		Term t =null;

		try {
			// colog.g:58:36: (t= term ( ',' t= term )* )
			// colog.g:59:4: t= term ( ',' t= term )*
			{
			value = new Vector<Term>() ;
			pushFollow(FOLLOW_term_in_terms438);
			t=term();
			state._fsp--;

			value.add(t);
			// colog.g:61:4: ( ',' t= term )*
			loop9:
			while (true) {
				int alt9=2;
				int LA9_0 = input.LA(1);
				if ( (LA9_0==22) ) {
					alt9=1;
				}

				switch (alt9) {
				case 1 :
					// colog.g:61:5: ',' t= term
					{
					match(input,22,FOLLOW_22_in_terms447); 
					pushFollow(FOLLOW_term_in_terms451);
					t=term();
					state._fsp--;

					value.add(t);
					}
					break;

				default :
					break loop9;
				}
			}

			}

		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
		}
		finally {
			// do for sure before leaving
		}
		return value;
	}
	// $ANTLR end "terms"



	// $ANTLR start "term"
	// colog.g:63:1: term returns [Term value] : ( variable | number | functor );
	public final Term term() throws RecognitionException {
		Term value = null;


		ParserRuleReturnScope variable11 =null;
		ParserRuleReturnScope number12 =null;
		Functor functor13 =null;

		try {
			// colog.g:63:27: ( variable | number | functor )
			int alt10=3;
			switch ( input.LA(1) ) {
			case UPPER:
			case 36:
				{
				alt10=1;
				}
				break;
			case NUMERIC:
				{
				alt10=2;
				}
				break;
			case ALL:
			case DQUOTED:
			case LOWER:
			case QUOTED:
			case UOP:
			case 16:
			case 18:
			case 38:
				{
				alt10=3;
				}
				break;
			default:
				NoViableAltException nvae =
					new NoViableAltException("", 10, 0, input);
				throw nvae;
			}
			switch (alt10) {
				case 1 :
					// colog.g:64:4: variable
					{
					pushFollow(FOLLOW_variable_in_term474);
					variable11=variable();
					state._fsp--;

					value = (variable11!=null?((cologParser.variable_return)variable11).value:null); 
					}
					break;
				case 2 :
					// colog.g:65:6: number
					{
					pushFollow(FOLLOW_number_in_term483);
					number12=number();
					state._fsp--;

					value = new Functor((number12!=null?((cologParser.number_return)number12).value:null),0,Functor.FCNL);
					}
					break;
				case 3 :
					// colog.g:66:6: functor
					{
					pushFollow(FOLLOW_functor_in_term494);
					functor13=functor();
					state._fsp--;

					value = functor13 ; 
					}
					break;

			}
		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
		}
		finally {
			// do for sure before leaving
		}
		return value;
	}
	// $ANTLR end "term"


	public static class variable_return extends ParserRuleReturnScope {
		public Variable value;
	};


	// $ANTLR start "variable"
	// colog.g:69:1: variable returns [Variable value] : ( UPPER | '_' ) ( LOWER | UPPER | '_' | NUMERIC )* ;
	public final cologParser.variable_return variable() throws RecognitionException {
		cologParser.variable_return retval = new cologParser.variable_return();
		retval.start = input.LT(1);

		try {
			// colog.g:69:35: ( ( UPPER | '_' ) ( LOWER | UPPER | '_' | NUMERIC )* )
			// colog.g:70:4: ( UPPER | '_' ) ( LOWER | UPPER | '_' | NUMERIC )*
			{
			if ( input.LA(1)==UPPER||input.LA(1)==36 ) {
				input.consume();
				state.errorRecovery=false;
			}
			else {
				MismatchedSetException mse = new MismatchedSetException(null,input);
				throw mse;
			}
			// colog.g:70:16: ( LOWER | UPPER | '_' | NUMERIC )*
			loop11:
			while (true) {
				int alt11=2;
				int LA11_0 = input.LA(1);
				if ( (LA11_0==LOWER||LA11_0==NUMERIC||LA11_0==UPPER||LA11_0==36) ) {
					alt11=1;
				}

				switch (alt11) {
				case 1 :
					// colog.g:
					{
					if ( input.LA(1)==LOWER||input.LA(1)==NUMERIC||input.LA(1)==UPPER||input.LA(1)==36 ) {
						input.consume();
						state.errorRecovery=false;
					}
					else {
						MismatchedSetException mse = new MismatchedSetException(null,input);
						throw mse;
					}
					}
					break;

				default :
					break loop11;
				}
			}

			retval.value = new Variable(input.toString(retval.start,input.LT(-1))) ; 
			}

			retval.stop = input.LT(-1);

		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "variable"


	public static class name_return extends ParserRuleReturnScope {
		public String value;
	};


	// $ANTLR start "name"
	// colog.g:73:1: name returns [String value] : ( ( '~' )* ( '$' )? LOWER ( LOWER | UPPER | '_' | NUMERIC )* | QUOTED | DQUOTED | ALL variable );
	public final cologParser.name_return name() throws RecognitionException {
		cologParser.name_return retval = new cologParser.name_return();
		retval.start = input.LT(1);

		try {
			// colog.g:73:28: ( ( '~' )* ( '$' )? LOWER ( LOWER | UPPER | '_' | NUMERIC )* | QUOTED | DQUOTED | ALL variable )
			int alt15=4;
			switch ( input.LA(1) ) {
			case LOWER:
			case 16:
			case 38:
				{
				alt15=1;
				}
				break;
			case QUOTED:
				{
				alt15=2;
				}
				break;
			case DQUOTED:
				{
				alt15=3;
				}
				break;
			case ALL:
				{
				alt15=4;
				}
				break;
			default:
				NoViableAltException nvae =
					new NoViableAltException("", 15, 0, input);
				throw nvae;
			}
			switch (alt15) {
				case 1 :
					// colog.g:74:4: ( '~' )* ( '$' )? LOWER ( LOWER | UPPER | '_' | NUMERIC )*
					{
					// colog.g:74:4: ( '~' )*
					loop12:
					while (true) {
						int alt12=2;
						int LA12_0 = input.LA(1);
						if ( (LA12_0==38) ) {
							alt12=1;
						}

						switch (alt12) {
						case 1 :
							// colog.g:74:4: '~'
							{
							match(input,38,FOLLOW_38_in_name564); 
							}
							break;

						default :
							break loop12;
						}
					}

					// colog.g:74:9: ( '$' )?
					int alt13=2;
					int LA13_0 = input.LA(1);
					if ( (LA13_0==16) ) {
						alt13=1;
					}
					switch (alt13) {
						case 1 :
							// colog.g:74:9: '$'
							{
							match(input,16,FOLLOW_16_in_name567); 
							}
							break;

					}

					match(input,LOWER,FOLLOW_LOWER_in_name570); 
					// colog.g:74:20: ( LOWER | UPPER | '_' | NUMERIC )*
					loop14:
					while (true) {
						int alt14=2;
						int LA14_0 = input.LA(1);
						if ( (LA14_0==LOWER||LA14_0==NUMERIC||LA14_0==UPPER||LA14_0==36) ) {
							alt14=1;
						}

						switch (alt14) {
						case 1 :
							// colog.g:
							{
							if ( input.LA(1)==LOWER||input.LA(1)==NUMERIC||input.LA(1)==UPPER||input.LA(1)==36 ) {
								input.consume();
								state.errorRecovery=false;
							}
							else {
								MismatchedSetException mse = new MismatchedSetException(null,input);
								throw mse;
							}
							}
							break;

						default :
							break loop14;
						}
					}

					retval.value = input.toString(retval.start,input.LT(-1)) ;
					}
					break;
				case 2 :
					// colog.g:75:6: QUOTED
					{
					match(input,QUOTED,FOLLOW_QUOTED_in_name600); 
					 retval.value = input.toString(retval.start,input.LT(-1)) ; 
					}
					break;
				case 3 :
					// colog.g:76:6: DQUOTED
					{
					match(input,DQUOTED,FOLLOW_DQUOTED_in_name610); 
					 retval.value = input.toString(retval.start,input.LT(-1)) ; 
					}
					break;
				case 4 :
					// colog.g:77:6: ALL variable
					{
					match(input,ALL,FOLLOW_ALL_in_name620); 
					pushFollow(FOLLOW_variable_in_name622);
					variable();
					state._fsp--;

					retval.value = input.toString(retval.start,input.LT(-1)) ;
					}
					break;

			}
			retval.stop = input.LT(-1);

		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "name"


	public static class number_return extends ParserRuleReturnScope {
		public String value;
	};


	// $ANTLR start "number"
	// colog.g:80:1: number returns [String value] : ( NUMERIC )+ ;
	public final cologParser.number_return number() throws RecognitionException {
		cologParser.number_return retval = new cologParser.number_return();
		retval.start = input.LT(1);

		try {
			// colog.g:80:30: ( ( NUMERIC )+ )
			// colog.g:81:4: ( NUMERIC )+
			{
			// colog.g:81:4: ( NUMERIC )+
			int cnt16=0;
			loop16:
			while (true) {
				int alt16=2;
				int LA16_0 = input.LA(1);
				if ( (LA16_0==NUMERIC) ) {
					alt16=1;
				}

				switch (alt16) {
				case 1 :
					// colog.g:81:4: NUMERIC
					{
					match(input,NUMERIC,FOLLOW_NUMERIC_in_number644); 
					}
					break;

				default :
					if ( cnt16 >= 1 ) break loop16;
					EarlyExitException eee = new EarlyExitException(16, input);
					throw eee;
				}
				cnt16++;
			}

			retval.value = input.toString(retval.start,input.LT(-1)) ; 
			}

			retval.stop = input.LT(-1);

		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "number"


	public static class bop_return extends ParserRuleReturnScope {
	};


	// $ANTLR start "bop"
	// colog.g:84:1: bop : ( '$' )? ( '&' | '|' | ';' | '=>' | '->' | '*' | '#' | '+' | '/' | '\\\\' | '- ' | '^' ) ;
	public final cologParser.bop_return bop() throws RecognitionException {
		cologParser.bop_return retval = new cologParser.bop_return();
		retval.start = input.LT(1);

		try {
			// colog.g:84:6: ( ( '$' )? ( '&' | '|' | ';' | '=>' | '->' | '*' | '#' | '+' | '/' | '\\\\' | '- ' | '^' ) )
			// colog.g:85:7: ( '$' )? ( '&' | '|' | ';' | '=>' | '->' | '*' | '#' | '+' | '/' | '\\\\' | '- ' | '^' )
			{
			// colog.g:85:7: ( '$' )?
			int alt17=2;
			int LA17_0 = input.LA(1);
			if ( (LA17_0==16) ) {
				alt17=1;
			}
			switch (alt17) {
				case 1 :
					// colog.g:85:7: '$'
					{
					match(input,16,FOLLOW_16_in_bop669); 
					}
					break;

			}

			if ( input.LA(1)==15||input.LA(1)==17||(input.LA(1) >= 20 && input.LA(1) <= 21)||(input.LA(1) >= 23 && input.LA(1) <= 24)||(input.LA(1) >= 26 && input.LA(1) <= 27)||input.LA(1)==31||(input.LA(1) >= 34 && input.LA(1) <= 35)||input.LA(1)==37 ) {
				input.consume();
				state.errorRecovery=false;
			}
			else {
				MismatchedSetException mse = new MismatchedSetException(null,input);
				throw mse;
			}
			}

			retval.stop = input.LT(-1);

		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "bop"


	public static class pred_return extends ParserRuleReturnScope {
	};


	// $ANTLR start "pred"
	// colog.g:87:1: pred : ( '$' )? ( '=' | '!=' | '<' | '>' | '>=' | '<=' ) ;
	public final cologParser.pred_return pred() throws RecognitionException {
		cologParser.pred_return retval = new cologParser.pred_return();
		retval.start = input.LT(1);

		try {
			// colog.g:87:7: ( ( '$' )? ( '=' | '!=' | '<' | '>' | '>=' | '<=' ) )
			// colog.g:87:10: ( '$' )? ( '=' | '!=' | '<' | '>' | '>=' | '<=' )
			{
			// colog.g:87:10: ( '$' )?
			int alt18=2;
			int LA18_0 = input.LA(1);
			if ( (LA18_0==16) ) {
				alt18=1;
			}
			switch (alt18) {
				case 1 :
					// colog.g:87:10: '$'
					{
					match(input,16,FOLLOW_16_in_pred732); 
					}
					break;

			}

			if ( input.LA(1)==14||(input.LA(1) >= 28 && input.LA(1) <= 30)||(input.LA(1) >= 32 && input.LA(1) <= 33) ) {
				input.consume();
				state.errorRecovery=false;
			}
			else {
				MismatchedSetException mse = new MismatchedSetException(null,input);
				throw mse;
			}
			}

			retval.stop = input.LT(-1);

		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "pred"

	// Delegated rules


	protected DFA1 dfa1 = new DFA1(this);
	protected DFA8 dfa8 = new DFA8(this);
	static final String DFA1_eotS =
		"\27\uffff";
	static final String DFA1_eofS =
		"\27\uffff";
	static final String DFA1_minS =
		"\1\4\3\6\2\16\1\14\1\uffff\1\6\1\4\1\6\1\10\3\6\2\16\1\14\1\6\1\uffff"+
		"\3\6";
	static final String DFA1_maxS =
		"\2\46\1\6\1\44\2\41\1\44\1\uffff\1\44\1\46\1\44\1\41\1\46\1\6\1\44\2\41"+
		"\2\44\1\uffff\3\44";
	static final String DFA1_acceptS =
		"\7\uffff\1\2\13\uffff\1\1\3\uffff";
	static final String DFA1_specialS =
		"\27\uffff}>";
	static final String[] DFA1_transitionS = {
			"\1\6\1\5\1\3\1\uffff\1\7\1\4\1\uffff\2\7\3\uffff\1\2\1\uffff\1\7\21\uffff"+
			"\1\7\1\uffff\1\1",
			"\1\3\11\uffff\1\2\25\uffff\1\1",
			"\1\3",
			"\1\10\1\uffff\1\10\3\uffff\1\10\1\uffff\1\7\1\uffff\1\7\1\uffff\1\7"+
			"\3\uffff\1\7\5\uffff\2\7\1\11\3\7\2\uffff\1\10",
			"\1\7\1\uffff\1\7\1\uffff\1\7\3\uffff\1\7\5\uffff\2\7\1\11\3\7",
			"\1\7\1\uffff\1\7\1\uffff\1\7\3\uffff\1\7\5\uffff\2\7\1\11\3\7",
			"\1\12\27\uffff\1\12",
			"",
			"\1\10\1\uffff\1\10\3\uffff\1\10\1\uffff\1\7\1\uffff\1\7\1\uffff\1\7"+
			"\3\uffff\1\7\5\uffff\2\7\1\11\3\7\2\uffff\1\10",
			"\1\21\1\20\1\16\1\uffff\1\13\1\17\1\uffff\2\7\3\uffff\1\15\1\uffff\1"+
			"\7\21\uffff\1\7\1\uffff\1\14",
			"\1\22\1\uffff\1\22\3\uffff\1\22\1\uffff\1\7\1\uffff\1\7\1\uffff\1\7"+
			"\3\uffff\1\7\5\uffff\2\7\1\11\3\7\2\uffff\1\22",
			"\1\13\5\uffff\1\7\1\uffff\1\7\5\uffff\1\7\2\uffff\1\23\2\uffff\6\7",
			"\1\16\11\uffff\1\15\25\uffff\1\14",
			"\1\16",
			"\1\24\1\uffff\1\24\3\uffff\1\24\1\uffff\1\7\1\uffff\1\7\1\uffff\1\7"+
			"\3\uffff\1\7\2\uffff\1\23\2\uffff\6\7\2\uffff\1\24",
			"\1\7\1\uffff\1\7\1\uffff\1\7\3\uffff\1\7\2\uffff\1\23\2\uffff\6\7",
			"\1\7\1\uffff\1\7\1\uffff\1\7\3\uffff\1\7\2\uffff\1\23\2\uffff\6\7",
			"\1\25\27\uffff\1\25",
			"\1\22\1\uffff\1\22\3\uffff\1\22\1\uffff\1\7\1\uffff\1\7\1\uffff\1\7"+
			"\3\uffff\1\7\5\uffff\2\7\1\11\3\7\2\uffff\1\22",
			"",
			"\1\24\1\uffff\1\24\3\uffff\1\24\1\uffff\1\7\1\uffff\1\7\1\uffff\1\7"+
			"\3\uffff\1\7\2\uffff\1\23\2\uffff\6\7\2\uffff\1\24",
			"\1\26\1\uffff\1\26\3\uffff\1\26\1\uffff\1\7\1\uffff\1\7\1\uffff\1\7"+
			"\3\uffff\1\7\2\uffff\1\23\2\uffff\6\7\2\uffff\1\26",
			"\1\26\1\uffff\1\26\3\uffff\1\26\1\uffff\1\7\1\uffff\1\7\1\uffff\1\7"+
			"\3\uffff\1\7\2\uffff\1\23\2\uffff\6\7\2\uffff\1\26"
	};

	static final short[] DFA1_eot = DFA.unpackEncodedString(DFA1_eotS);
	static final short[] DFA1_eof = DFA.unpackEncodedString(DFA1_eofS);
	static final char[] DFA1_min = DFA.unpackEncodedStringToUnsignedChars(DFA1_minS);
	static final char[] DFA1_max = DFA.unpackEncodedStringToUnsignedChars(DFA1_maxS);
	static final short[] DFA1_accept = DFA.unpackEncodedString(DFA1_acceptS);
	static final short[] DFA1_special = DFA.unpackEncodedString(DFA1_specialS);
	static final short[][] DFA1_transition;

	static {
		int numStates = DFA1_transitionS.length;
		DFA1_transition = new short[numStates][];
		for (int i=0; i<numStates; i++) {
			DFA1_transition[i] = DFA.unpackEncodedString(DFA1_transitionS[i]);
		}
	}

	protected class DFA1 extends DFA {

		public DFA1(BaseRecognizer recognizer) {
			this.recognizer = recognizer;
			this.decisionNumber = 1;
			this.eot = DFA1_eot;
			this.eof = DFA1_eof;
			this.min = DFA1_min;
			this.max = DFA1_max;
			this.accept = DFA1_accept;
			this.special = DFA1_special;
			this.transition = DFA1_transition;
		}
		@Override
		public String getDescription() {
			return "()* loopback of 25:4: ( hint )*";
		}
	}

	static final String DFA8_eotS =
		"\16\uffff";
	static final String DFA8_eofS =
		"\16\uffff";
	static final String DFA8_minS =
		"\1\4\3\6\2\16\1\14\2\uffff\1\6\2\uffff\2\6";
	static final String DFA8_maxS =
		"\2\46\1\6\3\45\1\44\2\uffff\1\45\2\uffff\2\45";
	static final String DFA8_acceptS =
		"\7\uffff\1\3\1\4\1\uffff\1\1\1\2\2\uffff";
	static final String DFA8_specialS =
		"\16\uffff}>";
	static final String[] DFA8_transitionS = {
			"\1\6\1\5\1\3\2\uffff\1\4\1\uffff\1\10\4\uffff\1\2\1\uffff\1\7\23\uffff"+
			"\1\1",
			"\1\3\11\uffff\1\2\25\uffff\1\1",
			"\1\3",
			"\1\11\1\uffff\1\11\3\uffff\1\11\1\uffff\4\13\1\12\21\13\1\11\1\13",
			"\4\13\1\12\21\13\1\uffff\1\13",
			"\4\13\1\12\21\13\1\uffff\1\13",
			"\1\14\27\uffff\1\14",
			"",
			"",
			"\1\11\1\uffff\1\11\3\uffff\1\11\1\uffff\4\13\1\12\21\13\1\11\1\13",
			"",
			"",
			"\1\15\1\uffff\1\15\3\uffff\1\15\1\uffff\4\13\1\12\21\13\1\15\1\13",
			"\1\15\1\uffff\1\15\3\uffff\1\15\1\uffff\4\13\1\12\21\13\1\15\1\13"
	};

	static final short[] DFA8_eot = DFA.unpackEncodedString(DFA8_eotS);
	static final short[] DFA8_eof = DFA.unpackEncodedString(DFA8_eofS);
	static final char[] DFA8_min = DFA.unpackEncodedStringToUnsignedChars(DFA8_minS);
	static final char[] DFA8_max = DFA.unpackEncodedStringToUnsignedChars(DFA8_maxS);
	static final short[] DFA8_accept = DFA.unpackEncodedString(DFA8_acceptS);
	static final short[] DFA8_special = DFA.unpackEncodedString(DFA8_specialS);
	static final short[][] DFA8_transition;

	static {
		int numStates = DFA8_transitionS.length;
		DFA8_transition = new short[numStates][];
		for (int i=0; i<numStates; i++) {
			DFA8_transition[i] = DFA.unpackEncodedString(DFA8_transitionS[i]);
		}
	}

	protected class DFA8 extends DFA {

		public DFA8(BaseRecognizer recognizer) {
			this.recognizer = recognizer;
			this.decisionNumber = 8;
			this.eot = DFA8_eot;
			this.eof = DFA8_eof;
			this.min = DFA8_min;
			this.max = DFA8_max;
			this.accept = DFA8_accept;
			this.special = DFA8_special;
			this.transition = DFA8_transition;
		}
		@Override
		public String getDescription() {
			return "51:1: functor returns [Functor value] : ( name '(' terms ')' | name | '(' t1= term bop t2= term ')' | UOP t= term );";
		}
	}

	public static final BitSet FOLLOW_theory_in_test35 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_hint_in_theory53 = new BitSet(new long[]{0x0000005000051B70L});
	public static final BitSet FOLLOW_rule_in_theory60 = new BitSet(new long[]{0x0000000002000000L});
	public static final BitSet FOLLOW_25_in_theory66 = new BitSet(new long[]{0x0000005000051B72L});
	public static final BitSet FOLLOW_name_in_hint81 = new BitSet(new long[]{0x0000000040000000L});
	public static final BitSet FOLLOW_30_in_hint83 = new BitSet(new long[]{0x0000004000010370L});
	public static final BitSet FOLLOW_number_in_hint88 = new BitSet(new long[]{0x0000000002000000L});
	public static final BitSet FOLLOW_name_in_hint119 = new BitSet(new long[]{0x0000000002000000L});
	public static final BitSet FOLLOW_25_in_hint124 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_conjunction_in_rule142 = new BitSet(new long[]{0x0000000080000000L});
	public static final BitSet FOLLOW_31_in_rule144 = new BitSet(new long[]{0x0000005000051B70L});
	public static final BitSet FOLLOW_disjunction_in_rule146 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_conjunction_in_disjunction179 = new BitSet(new long[]{0x0000002008000002L});
	public static final BitSet FOLLOW_set_in_disjunction188 = new BitSet(new long[]{0x0000005000051B70L});
	public static final BitSet FOLLOW_conjunction_in_disjunction197 = new BitSet(new long[]{0x0000002008000002L});
	public static final BitSet FOLLOW_predicate_in_conjunction227 = new BitSet(new long[]{0x0000000000400002L});
	public static final BitSet FOLLOW_22_in_conjunction237 = new BitSet(new long[]{0x0000005000051B70L});
	public static final BitSet FOLLOW_predicate_in_conjunction241 = new BitSet(new long[]{0x0000000000400002L});
	public static final BitSet FOLLOW_functor_in_predicate261 = new BitSet(new long[]{0x0000000370014002L});
	public static final BitSet FOLLOW_pred_in_predicate268 = new BitSet(new long[]{0x0000005000051B70L});
	public static final BitSet FOLLOW_term_in_predicate272 = new BitSet(new long[]{0x0000000370014002L});
	public static final BitSet FOLLOW_variable_in_predicate291 = new BitSet(new long[]{0x0000000370014000L});
	public static final BitSet FOLLOW_pred_in_predicate293 = new BitSet(new long[]{0x0000005000051B70L});
	public static final BitSet FOLLOW_term_in_predicate297 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_number_in_predicate308 = new BitSet(new long[]{0x0000000370014000L});
	public static final BitSet FOLLOW_pred_in_predicate310 = new BitSet(new long[]{0x0000005000051B70L});
	public static final BitSet FOLLOW_term_in_predicate314 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_name_in_functor339 = new BitSet(new long[]{0x0000000000040000L});
	public static final BitSet FOLLOW_18_in_functor341 = new BitSet(new long[]{0x0000005000051B70L});
	public static final BitSet FOLLOW_terms_in_functor343 = new BitSet(new long[]{0x0000000000080000L});
	public static final BitSet FOLLOW_19_in_functor345 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_name_in_functor365 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_18_in_functor375 = new BitSet(new long[]{0x0000005000051B70L});
	public static final BitSet FOLLOW_term_in_functor379 = new BitSet(new long[]{0x0000002C8DB38000L});
	public static final BitSet FOLLOW_bop_in_functor381 = new BitSet(new long[]{0x0000005000051B70L});
	public static final BitSet FOLLOW_term_in_functor385 = new BitSet(new long[]{0x0000000000080000L});
	public static final BitSet FOLLOW_19_in_functor387 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_UOP_in_functor397 = new BitSet(new long[]{0x0000005000051B70L});
	public static final BitSet FOLLOW_term_in_functor401 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_term_in_terms438 = new BitSet(new long[]{0x0000000000400002L});
	public static final BitSet FOLLOW_22_in_terms447 = new BitSet(new long[]{0x0000005000051B70L});
	public static final BitSet FOLLOW_term_in_terms451 = new BitSet(new long[]{0x0000000000400002L});
	public static final BitSet FOLLOW_variable_in_term474 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_number_in_term483 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_functor_in_term494 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_set_in_variable519 = new BitSet(new long[]{0x0000001000001142L});
	public static final BitSet FOLLOW_38_in_name564 = new BitSet(new long[]{0x0000004000010040L});
	public static final BitSet FOLLOW_16_in_name567 = new BitSet(new long[]{0x0000000000000040L});
	public static final BitSet FOLLOW_LOWER_in_name570 = new BitSet(new long[]{0x0000001000001142L});
	public static final BitSet FOLLOW_QUOTED_in_name600 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_DQUOTED_in_name610 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_ALL_in_name620 = new BitSet(new long[]{0x0000001000001000L});
	public static final BitSet FOLLOW_variable_in_name622 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_NUMERIC_in_number644 = new BitSet(new long[]{0x0000000000000102L});
	public static final BitSet FOLLOW_16_in_bop669 = new BitSet(new long[]{0x0000002C8DB28000L});
	public static final BitSet FOLLOW_set_in_bop671 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_16_in_pred732 = new BitSet(new long[]{0x0000000370004000L});
	public static final BitSet FOLLOW_set_in_pred734 = new BitSet(new long[]{0x0000000000000002L});
}
