package sam.util ;

import java.util.* ;

/**
  *  Wrapper for a table key pattern.
  *  27 May 2014 
   */
public class Pattern {
   public boolean[] key ;
   public boolean factual ;    // all args bound
   public boolean subfactual ; // some arg bound & some arg not bound
      
   public Pattern(boolean[] k) {
      this.key = k ;
      this.set() ; 
   }
 
   //  3-val  factual  partial 
   // p         true    false
   // p(a,b)    true    false 
   // p(a,X)    false   true
   // p(X,Y)    false   false
   ////////////////////////////////////
   private void set() {
      //this.factual = false ; 
      //this.partial = false ;
      int falsecount = 0 ;
      for (int i = 0 ; i < this.key.length ; i++) {
         if (!this.key[i]) falsecount++ ;
      }  
      if (falsecount == 0) this.factual = true ;
      else if (falsecount < this.key.length) 
        this.subfactual = true ;
      else return ; 
   }

   public boolean equals(Object ob) { 
      for (int i = 0 ; i < this.key.length ; i++)
         if (this.key[i] != ((Pattern)ob).key[i]) return false ;
      return true ; 
   }

   public String toString() {
      StringBuffer sb = new StringBuffer() ; 
      sb.append("[") ; 
      for (int i = 0 ; i < this.key.length ; i++) {
          sb.append(this.key[i]) ;
          if (i < this.key.length -1)
             sb.append(",") ;
      }
      sb.append("]") ; 
      return sb.toString() ; 
   }

   // some tests
   public static void main(String[] args) { 
      Pattern p0 = new Pattern(new boolean[0]) ; 
      System.out.println(p0.factual) ;
      System.out.println(p0.subfactual) ;
      System.out.println("-----") ; 
      boolean[] k1 = {true,true} ; 
      Pattern p1 = new Pattern(k1) ; 
      System.out.println("factual="+p1.factual) ;
      System.out.println("partial="+p1.subfactual) ;
      System.out.println("-----") ;

   }
}

