package sam.util ; 

/**
  *  RoundRobin utility, minimal
  *  circular iterator 0..n  
  *  Use an S to store next's for states of a RR,
  *  rather than a java.util.Stack<Q>.
  */
public class RoundRobin { 
   public int next ;  // CAN SET
   public int last ; //  size = last+1

   public RoundRobin(int n) {
      last = n-1 ;
      next = 0 ; 
   }

   public void reset() { 
      next = 0 ; 
   }

   public int next() {
      int ret = next ; 
      if (next == last) next = 0 ; 
      else next++ ;
      return ret ; 
   }

   public RoundRobin clone() { 
      RoundRobin clone = new RoundRobin(this.last+1) ; 
      clone.next = this.next ;
      return clone ;
   }

   public static void main(String[] args) {
      int size = Integer.parseInt(args[0]) ;
      RoundRobin rr = new RoundRobin(size) ; 
      rr.next = 5 ;  // set so next is 3
      for(int s = 0 ; s < size ; s++) 
         System.out.println(rr.next()) ;
      System.out.println(rr.next()) ;

   } 
      

}
